'''
import numpy as np
import matplotlib.pyplot as plt
import pylab
import numpy as np
import cv2 

cap = cv2.VideoCapture('D:/service2019/video/1.mp4') 
fps = cap.get(cv2.CAP_PROP_FPS)
size = (int(cap.get(cv2.CAP_PROP_FRAME_WIDTH)),int(cap.get(cv2.CAP_PROP_FRAME_HEIGHT)))
out = cv2.VideoWriter('D:/service2019/video/test.avi',cv2.VideoWriter_fourcc("I", "4", "2", "0"), fps, size)

ret, frame = cap.read()
while ret:
    cv2.imshow('image', frame)
    k = cv2.waitKey(int(1000/fps))
    #out.write(frame)
    ret, frame = cap.read()


cap.release()
out.release()
cv2.destroyAllWindows()
'''

# -*- coding: utf-8 -*-
from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

from math import sqrt
import tensorflow as tf
import tiny_face_model
import util
from argparse import ArgumentParser
import cv2
import scipy.io
import numpy as np
import matplotlib.pyplot as plt
#import cv2
import pickle

#import pylab as pl
import time
import os
import sys
from scipy.special import expit
import glob

import pandas as pd


MAX_INPUT_DIM = 5000.0

mulboxes = []

def overlay_bounding_boxes(raw_img, refined_bboxes, lw):
  """Overlay bounding boxes of face on images.
    Args:
      raw_img:
        A target image.
      refined_bboxes:
        Bounding boxes of detected faces.
      lw: 
        Line width of bounding boxes. If zero specified,
        this is determined based on confidence of each detection.
    Returns:
      None.
  """

  # Overlay bounding boxes on an image with the color based on the confidence.
  for r in refined_bboxes:
    _score = expit(r[5])
    cm_idx = int(np.ceil(_score * 255))
    rect_color = [int(np.ceil(x * 255)) for x in util.cm_data[cm_idx]]  # parula
    _lw = lw
    if lw == 0:  # line width of each bounding box is adaptively determined.
      bw, bh = r[3] - r[1] + 1, r[4] - r[1] + 1
      _lw = 1 if min(bw, bh) <= 20 else max(2, min(3, min(bh / 20, bw / 20)))
      _lw = int(np.ceil(_lw * _score))

    _r = [int(x) for x in r[1:5]]
    #(_r[0], _r[1])框的左上角 (_r[2], _r[3])框的右下角

    cv2.rectangle(raw_img, (_r[0], _r[1]), (_r[2], _r[3]), rect_color, _lw)
    
    
def evaluate(weight_file_path, video_path, prob_thresh=0.6, nms_thresh=0.1, lw=3, display=False):
  cap = cv2.VideoCapture(video_path)
  fps = cap.get(cv2.CAP_PROP_FPS)
  size = (int(cap.get(cv2.CAP_PROP_FRAME_WIDTH)),int(cap.get(cv2.CAP_PROP_FRAME_HEIGHT)))
  #out = cv2.VideoWriter('D:/service2019/video/out3.mp4',cv2.VideoWriter_fourcc('m', 'p', '4', 'v'), fps, size)
  count = cap.get(7)
  print(count)
  print(type(count))
  """Detect faces in images.
  Args:
    prob_thresh:
        The threshold of detection confidence.
    nms_thresh:
        The overlap threshold of non maximum suppression
    weight_file_path: 
        A pretrained weight file in the pickle format 
        generated by matconvnet_hr101_to_tf.py.
    data_dir: 
        A directory which contains images.
    output_dir: 
        A directory into which images with detected faces are output.
    lw: 
        Line width of bounding boxes. If zero specified,
        this is determined based on confidence of each detection.
    display:
        Display tiny face images on window.
  Returns:
    None.
  """

  # placeholder of input images.  Currently batch size of one is supported.
  x = tf.placeholder(tf.float32, [1, None, None, 3]) # n, h, w, c

  # Create the tiny face model which weights are loaded from a pretrained
  # model.
  model = tiny_face_model.Model(weight_file_path)
  score_final = model.tiny_face(x)

  # Find image files in data_dir.
  #filenames = []
  #for ext in ('*.png', '*.gif', '*.jpg', '*.jpeg'):
  # filenames.extend(glob.glob(os.path.join(data_dir, ext)))

  # Load an average image and clusters(reference boxes of templates).
  with open(weight_file_path, "rb") as f:
    _, mat_params_dict = pickle.load(f)

  average_image = model.get_data_by_key("average_image")
  clusters = model.get_data_by_key("clusters")
  clusters_h = clusters[:, 3] - clusters[:, 1] + 1
  clusters_w = clusters[:, 2] - clusters[:, 0] + 1
  normal_idx = np.where(clusters[:, 4] == 1)

  # main
  with tf.Session() as sess:
    sess.run(tf.global_variables_initializer())
    
    ret, frame = cap.read()
    counting = 0.0
    while ret:
      #fname = filename.split(os.sep)[-1]
      #raw_img = cv2.imread(filename)
      raw_img = frame
      raw_img = cv2.cvtColor(raw_img, cv2.COLOR_BGR2RGB)
      raw_img_f = raw_img.astype(np.float32)
      
      def _calc_scales():
        raw_h, raw_w = raw_img.shape[0], raw_img.shape[1]
        min_scale = min(np.floor(np.log2(np.max(clusters_w[normal_idx] / raw_w))),
                        np.floor(np.log2(np.max(clusters_h[normal_idx] / raw_h))))
        max_scale = min(1.0, -np.log2(max(raw_h, raw_w) / MAX_INPUT_DIM))
        scales_down = np.arange(min_scale, 0, 1.)
        scales_up = np.arange(0.5, max_scale, 0.5)
        scales_pow = np.hstack((scales_down, scales_up))
        scales = np.power(2.0, scales_pow)
        return scales

      scales = _calc_scales()
      start = time.time()

      # initialize output
      bboxes = np.empty(shape=(0, 5))

      # process input at different scales
      for s in scales:
       # print("Processing {} at scale {:.4f}".format(fname, s))
        print("at scale {:.4f}".format(s))
        img = cv2.resize(raw_img_f, (0, 0), fx=s, fy=s, interpolation=cv2.INTER_LINEAR)
        img = img - average_image
        img = img[np.newaxis, :]

        # we don't run every template on every scale ids of templates to ignore
        tids = list(range(4, 12)) + ([] if s <= 1.0 else list(range(18, 25)))
        ignoredTids = list(set(range(0, clusters.shape[0])) - set(tids))

        # run through the net
        score_final_tf = sess.run(score_final, feed_dict={x: img})

        # collect scores
        score_cls_tf, score_reg_tf = score_final_tf[:, :, :, :25], score_final_tf[:, :, :, 25:125]
        prob_cls_tf = expit(score_cls_tf)
        prob_cls_tf[0, :, :, ignoredTids] = 0.0

        def _calc_bounding_boxes():
          # threshold for detection
          _, fy, fx, fc = np.where(prob_cls_tf > prob_thresh)

          # interpret heatmap into bounding boxes
          cy = fy * 8 - 1
          cx = fx * 8 - 1
          ch = clusters[fc, 3] - clusters[fc, 1] + 1
          cw = clusters[fc, 2] - clusters[fc, 0] + 1

          # extract bounding box refinement
          Nt = clusters.shape[0]
          tx = score_reg_tf[0, :, :, 0:Nt]
          ty = score_reg_tf[0, :, :, Nt:2 * Nt]
          tw = score_reg_tf[0, :, :, 2 * Nt:3 * Nt]
          th = score_reg_tf[0, :, :, 3 * Nt:4 * Nt]

          # refine bounding boxes
          dcx = cw * tx[fy, fx, fc]
          dcy = ch * ty[fy, fx, fc]
          rcx = cx + dcx
          rcy = cy + dcy
          rcw = cw * np.exp(tw[fy, fx, fc])
          rch = ch * np.exp(th[fy, fx, fc])

          scores = score_cls_tf[0, fy, fx, fc]
          tmp_bboxes = np.vstack((rcx - rcw / 2, rcy - rch / 2, rcx + rcw / 2, rcy + rch / 2))
          tmp_bboxes = np.vstack((tmp_bboxes / s, scores))
          tmp_bboxes = tmp_bboxes.transpose()
          return tmp_bboxes

        tmp_bboxes = _calc_bounding_boxes()
        bboxes = np.vstack((bboxes, tmp_bboxes)) # <class 'tuple'>: (5265, 5)


      #print("time {:.2f} secs for {}".format(time.time() - start, fname))
      print("time {:.2f} secs for 1".format(time.time() - start))

      # non maximum suppression
      # refind_idx = util.nms(bboxes, nms_thresh)
      refind_idx = tf.image.non_max_suppression(tf.convert_to_tensor(bboxes[:, :4], dtype=tf.float32),
                                                   tf.convert_to_tensor(bboxes[:, 4], dtype=tf.float32),
                                                   max_output_size=bboxes.shape[0], iou_threshold=nms_thresh)
      refind_idx = sess.run(refind_idx)
      refined_bboxes = bboxes[refind_idx]
      #print(type(refined_bboxes))
      #print(list(refined_bboxes))
      #refined_bboxes[0,1,2,3]分别是左，上，右，下（float）,可能有多组

      ##判断是否为红色的函数
      #def is_same(x1,y1,x2,y2):
      #  sum=0
      #  sum_same=0
      #  r,g,b=raw_img_f[int((y2+y1)/2)][int((x2+x2)/2)]
      #  for i in range(int(y1),int(y2)):
      #    for j in range(int(x1),int(x2)):
      #      sum+=1
      #      kkk=sqrt(((raw_img_f[i][j][0]-r)/255)**2+((raw_img_f[i][j][1]-g)/255)**2+((raw_img_f[i][j][2]-b)/255)**2)#颜色相似
      #      if(kkk<1.2 and raw_img_f[i][j][0]+raw_img_f[i][j][1]+raw_img_f[i][j][2]<150): sum_same+=1
      #  if(sum_same/sum>0.6):return True
      #  else :return False

      #转化为头区域
      box_hel=[]
      
      for r in refined_bboxes:
          x1,y1,x2,y2=r[0],r[1],r[2],r[3]
          score=r[4]
          z=y1
          differ_x=x2-x1
          differ_y=y2-y1
          x1-=differ_y/4
          x2+=differ_y/4
          y1-=differ_y/1.5
          y2=z+differ_y/10
          if(r[3]>raw_img.shape[0]):r[3]=raw_img.shape[0]-5
          if(x2>raw_img.shape[1]):x2=raw_img.shape[1]-5
          if(x1<=0): x1=5
          if(y1<=0): y1=5
          #if(is_same(x1,y1-(y2-y1)*0.2,x2,y2)):
          onebox=[]
          onebox.append(x1)
          onebox.append(y1)
          onebox.append(x2)
          onebox.append(r[3])
          onebox.append(expit(score))
          onebox.insert(0,int(counting))
          box_hel.append(onebox)

      mulboxes.append(box_hel)

          
          #else:pass
      '''
      #print(box_hel)
     
      df=pd.DataFrame(box_hel)
      #print(df)
      #df.columns("filename","xmin","ymin","xmax","ymax","score")
      df.to_csv("D:/service2019/aaa.csv",index=False,header=False,mode="a+")
      '''



      #overlay_bounding_boxes(raw_img, box_hel, lw)
      
      if display:
        # plt.axis('off')
        plt.imshow(raw_img)
        plt.show()

      #raw_img = cv2.cvtColor(raw_img, cv2.COLOR_RGB2BGR)
      #out.write(raw_img)
      
      print('完成度：%.2f%%' % (counting/count*100))
      ret, frame = cap.read()
      counting += 1.0
      # save image with bounding boxes
      #raw_img = cv2.cvtColor(raw_img, cv2.COLOR_RGB2BGR)
      #cv2.imwrite(os.path.join(output_dir, fname), raw_img)
  cap.release()
  #out.release()
  #print(mulboxes)

def save_as_csv(mulboxes):
    df = pd.DataFrame(columns=('frame','xmin', 'ymin','xmax', 'ymax','score'))
    for boxes in mulboxes:
        _df = pd.DataFrame(boxes,columns=('frame','xmin', 'ymin','xmax', 'ymax','score'))
        df = pd.concat([df,_df],axis=0,ignore_index=True)
    #print(df)
    #df.to_csv("D:\学习\服务外包竞赛\Object-Detection_HelmetDetection-master\data/video_test.csv")
    return df




def video_test_Tiny_face(video_path):
  """
  argparse = ArgumentParser()
  argparse.add_argument('--weight_file_path', type=str, help='Pretrained weight file.', default="/path/to/mat2tf.pkl")
  argparse.add_argument('--data_dir', type=str, help='Image data directory.', default="/path/to/input_image_directory")
  argparse.add_argument('--output_dir', type=str, help='Output directory for images with faces detected.', default="/path/to/output_directory")
  argparse.add_argument('--prob_thresh', type=float, help='The threshold of detection confidence(default: 0.5).', default=0.5)
  argparse.add_argument('--nms_thresh', type=float, help='The overlap threshold of non maximum suppression(default: 0.1).', default=0.1)
  argparse.add_argument('--line_width', type=int, help='Line width of bounding boxes(0: auto).', default=3)
  argparse.add_argument('--display', type=bool, help='Display each image on window.', default=False)

  args = argparse.parse_args()

  # check arguments
  assert os.path.exists(args.weight_file_path), "weight file: " + args.weight_file_path + " not found."
  assert os.path.exists(args.data_dir), "data directory: " + args.data_dir + " not found."
  assert os.path.exists(args.output_dir), "output directory: " + args.output_dir + " not found."
  assert args.line_width >= 0, "line_width should be >= 0."
  """
  with tf.Graph().as_default():
    evaluate(weight_file_path='models\Tiny_Face/mat2tf.pkl',video_path=video_path)
    #evaluate(weight_file_path=args.weight_file_path, data_dir=args.data_dir, output_dir=args.output_dir,prob_thresh=args.prob_thresh, nms_thresh=args.nms_thresh,lw=args.line_width, display=args.display)
  df=save_as_csv(mulboxes)
  return df

